//
//  Hour16_DetailViewController.m
//  Estimator
//
//  Created by Jesse Feiler on 8/9/11.
//  Copyright (c) 2011 another. All rights reserved.
//

#import "Hour16_DetailViewController.h"

@interface Hour16_DetailViewController ()
@property (strong, nonatomic) UIPopoverController *popoverController;
- (void)configureView;
@end

@implementation Hour16_DetailViewController

@synthesize detailItem = _detailItem;
@synthesize name = _name;
@synthesize email = _email;
@synthesize address = _address;
@synthesize city = _city;
@synthesize state = _state;
@synthesize zip = _zip;
@synthesize popoverController = _myPopoverController;

- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    return self;
}

#pragma mark - Managing the detail item

- (void)setDetailItem:(id)newDetailItem
{
    if (_detailItem != newDetailItem) {
        
        if (_detailItem) {
            [self save];
        }
        
        _detailItem = newDetailItem;
        
        // Update the view.
        [self configureView];
    }

    self.title = [self.detailItem valueForKey:@"name"];
    
    if (self.popoverController != nil) {
        [self.popoverController dismissPopoverAnimated:YES];
    }        
}

- (void)configureView
{
    // Update the user interface for the detail item.

    self.name.text = [self.detailItem valueForKey:@"name"];
    self.email.text = [self.detailItem valueForKey:@"email"];
    self.address.text = [self.detailItem valueForKey:@"address"];
    self.city.text = [self.detailItem valueForKey:@"city"];
    self.state.text = [self.detailItem valueForKey:@"state"];
    self.zip.text = [self.detailItem valueForKey:@"zip"];

}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Release any cached data, images, etc that aren't in use.
}

#pragma mark - Object lifecycle

- (void) save {
    [self.detailItem setValue: self.name.text forKey:@"name"];
    [self.detailItem setValue: self.email.text forKey:@"email"];
    [self.detailItem setValue: self.address.text forKey:@"address"];
    [self.detailItem setValue: self.city.text forKey:@"city"];
    [self.detailItem setValue: self.state.text forKey:@"state"];
    [self.detailItem setValue: self.zip.text forKey:@"zip"];
    NSError *error;
    if (![self.detailItem.managedObjectContext save:&error]) {
        // Update to handle the error appropriately.
        NSLog(@"Unresolved error %@, %@", error, [error userInfo]);
        exit(-1);  // Fail
    }    
}

#pragma mark - View lifecycle

- (void)viewDidLoad
{
    [super viewDidLoad];
	// Do any additional setup after loading the view, typically from a nib.
    [self configureView];
}

- (void)viewDidUnload
{
    [self setName:nil];
    [self setEmail:nil];
    [self setAddress:nil];
    [self setCity:nil];
    [self setState:nil];
    [self setZip:nil];
    [super viewDidUnload];
    // Release any retained subviews of the main view.
    // e.g. self.myOutlet = nil;
}

- (void)viewWillAppear:(BOOL)animated
{
    [super viewWillAppear:animated];
//    self.name.text = [self.detailItem valueForKey:@"name"];
}

- (void)viewDidAppear:(BOOL)animated
{
    [super viewDidAppear:animated];
}

- (void)viewWillDisappear:(BOOL)animated
{
    [super viewWillDisappear:animated];
}

- (void)viewDidDisappear:(BOOL)animated
{
	[super viewDidDisappear:animated];
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    // Return YES for supported orientations
    if ([[UIDevice currentDevice] userInterfaceIdiom] == UIUserInterfaceIdiomPhone) {
        return (interfaceOrientation != UIInterfaceOrientationPortraitUpsideDown);
    } else {
        return YES;
    }
}

#pragma mark - Split view

- (void)splitViewController:(UISplitViewController *)splitController willHideViewController:(UIViewController *)viewController withBarButtonItem:(UIBarButtonItem *)barButtonItem forPopoverController:(UIPopoverController *)popoverController
{
    barButtonItem.title = NSLocalizedString(@"Master", @"Master");
    [self.navigationItem setLeftBarButtonItem:barButtonItem animated:YES];
    self.popoverController = popoverController;
}

- (void)splitViewController:(UISplitViewController *)splitController willShowViewController:(UIViewController *)viewController invalidatingBarButtonItem:(UIBarButtonItem *)barButtonItem
{
    // Called when the view is shown again in the split view, invalidating the button and popover controller.
    [self.navigationItem setLeftBarButtonItem:nil animated:YES];
    self.popoverController = nil;
}

@end
